Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions

# FreetypeFont Class Reference

This is a common base class for both DynamicTextFont and PNMTextMaker. More...

Inheritance diagram for FreetypeFont:

List of all members.

## Public Member Functions
int | getFontPixelSize ()
| This is used to report whether the requested pixel size is being only approximated by a fixed-pixel-size font.
float | getLineHeight ()
| Returns the number of units high each line of text is.
bool | getNativeAntialias ()
| Returns whether Freetype's built-in antialias mode is enabled.
float | getPixelSize ()
| Returns the size of the font in pixels, as it appears in the texture.
float | getPixelsPerUnit ()
| Returns the resolution of the texture map.
float | getPointSize ()
| Returns the point size of the font.
float | getScaleFactor ()
| Returns the antialiasing scale factor.
float | getSpaceAdvance ()
| Returns the number of units wide a space is.
| setNativeAntialias (bool native_antialias)
| Sets whether the Freetype library's built-in antialias mode is enabled.
bool | setPixelSize (float pixel_size)
| Computes the appropriate pixels_per_unit value to set the size of the font in the texture to the indicated number of pixels.
bool | setPixelsPerUnit (float pixels_per_unit)
| Set the resolution of the texture map, and hence the clarity of the resulting font.
bool | setPointSize (float point_size)
| Sets the point size of the font.
bool | setScaleFactor (float scale_factor)
| Sets the factor by which the font is rendered larger by the FreeType library before being filtered down to its actual size in the texture as specified by set_pixels_per_unit().
## Static Public Member Functions
static float | getPointsPerInch ()
| Returns the number of points in one inch.
static float | getPointsPerUnit ()
| Returns the point size of the font that is one Panda unit high.

## Detailed Description

This is a common base class for both DynamicTextFont and PNMTextMaker.

Both of these are utility classes that use the FreeType library to generate glyphs from fonts; this class abstracts out that common wrapper around FreeType.

## Member Function Documentation

int getFontPixelSize | ( |  | ) |

This is used to report whether the requested pixel size is being only approximated by a fixed-pixel-size font.

This returns 0 in the normal case, in which a scalable font is used, or the fixed-pixel-size font has exactly the requested pixel size.

If this returns non-zero, it is the pixel size of the font that we are using to approximate our desired size.

Reimplemented in DynamicTextFont.

float getLineHeight | ( |  | ) |

Returns the number of units high each line of text is.

Reimplemented in DynamicTextFont.

bool getNativeAntialias | ( |  | ) |

Returns whether Freetype's built-in antialias mode is enabled.

See set_native_antialias().

Reimplemented in DynamicTextFont.

float getPixelSize | ( |  | ) |

Returns the size of the font in pixels, as it appears in the texture.

float getPixelsPerUnit | ( |  | ) |

Returns the resolution of the texture map.

See set_pixels_per_unit().

Reimplemented in DynamicTextFont.

float getPointSize | ( |  | ) |

Returns the point size of the font.

Reimplemented in DynamicTextFont.

static float getPointsPerInch | ( |  | ) | `[static]`

Returns the number of points in one inch.

This is a universal typographic convention.

static float getPointsPerUnit | ( |  | ) | `[static]`

Returns the point size of the font that is one Panda unit high.

This is an arbitrary Panda convention for text, and is set to 10.0.

float getScaleFactor | ( |  | ) |

Returns the antialiasing scale factor.

See set_scale_factor().

Reimplemented in DynamicTextFont.

float getSpaceAdvance | ( |  | ) |

Returns the number of units wide a space is.

Reimplemented in DynamicTextFont.

setNativeAntialias | ( | bool | native_antialias | ) |

Sets whether the Freetype library's built-in antialias mode is enabled.

There are two unrelated ways to achieve antialiasing: with Freetype's native antialias mode, and with the use of a scale_factor greater than one. By default, both modes are enabled.

At low resolutions, some fonts may do better with one mode or the other. In general, Freetype's native antialiasing will produce less blurry results, but may introduce more artifacts.

Reimplemented in DynamicTextFont.

bool setPixelSize | ( | float | pixel_size | ) |

Computes the appropriate pixels_per_unit value to set the size of the font in the texture to the indicated number of pixels.

This is just another way to specify pixels_per_unit().

bool setPixelsPerUnit | ( | float | pixels_per_unit | ) |

Set the resolution of the texture map, and hence the clarity of the resulting font.

This sets the number of pixels in the texture map that are used for each onscreen unit.

Setting this number larger results in an easier to read font, but at the cost of more texture memory.

This should only be called before any characters have been requested out of the font, or immediately after calling clear().

Reimplemented in DynamicTextFont.

bool setPointSize | ( | float | point_size | ) |

Sets the point size of the font.

This controls the apparent size of the font onscreen. By convention, a 10 point font is about 1 screen unit high.

This should only be called before any characters have been requested out of the font, or immediately after calling clear().

Reimplemented in DynamicTextFont.

bool setScaleFactor | ( | float | scale_factor | ) |

Sets the factor by which the font is rendered larger by the FreeType library before being filtered down to its actual size in the texture as specified by set_pixels_per_unit().

This may be set to a number larger than 1.0 to improve the font's antialiasing (since FreeType doesn't really do a swell job of antialiasing by itself). There is some performance implication for setting this different than 1.0.

This should only be called before any characters have been requested out of the font, or immediately after calling clear().

Reimplemented in DynamicTextFont.

All Classes Namespaces Functions Variables Enumerations Enumerator Properties